
function[P,obj]=Spanno2(Qall,Yall,kList,id_expert,nd)

% Function [P,obj]=Spanno2(Qall,Yall,kList,id_expert,nd) execute Spanogram algortihm for nd=1 or 2 for  
% input : Qall = diag(Y) *K* diag(Y)   matrix of all data point 
%	  Yall = Annotation for all data points 
%	  kList = List of numbers corresponing to noisy labels in positive class and negative class 
%	  id_expert = List of index indicating datapoints annotated by experts
% 	  nd = level of approximation (for this code nd <=3).	
% output: P: probability of chance of being wrongly annotated
%         obj: objective value of optimization problem.  

% code for preprocessing 
non_expert=setdiff([1:1:length(Yall)],id_expert);
Q=[ Qall(non_expert,non_expert), sum(Qall(id_expert,non_expert),1)'; sum(Qall(id_expert,non_expert),1),sum(sum(Qall(id_expert,id_expert)))   ];
Mk=max(kList,[],1);
Q=0.5*(Q+Q');
Y=[Yall(non_expert);0];
N=length(Yall);
[E,D]=eigs(Q,nd,'la');
V=E.*repmat(diag(sqrt(D))',[length(Y),1]);
clear E D Qall
idP=find(Y==1);
idN=find(Y==-1);
obj=-1.00e+20*ones(size(kList,1),1);
P=ones(N,size(kList,1));



% coed for nd =1
if nd==1
[~,tempP]=sort(V(idP),'descend');
[~,tempN]=sort(V(idN),'descend');
for k=1:1:size(kList,1)
temp=ones(length(Y),1);
temp(([idP(tempP(1:kList(k,1)));idN(tempN(1:kList(k,2)))]))=-1;
objcur=temp'*Q*temp;
temp=ones(N,1);
temp(non_expert([idP(tempP(1:kList(k,1)));idN(tempN(1:kList(k,2)))]))=-1;
if obj(k)<objcur
    obj(k)=objcur;
    P(:,k)=temp;
end

temp=ones(length(Y),1);
temp(([idP(tempP(length(tempP)-kList(k,1)+1:length(tempP)));idN(tempN(length(tempN)-kList(k,2)+1:length(tempN)))]))=-1;
objcur=temp'*Q*temp;
temp=ones(N,1);
temp(non_expert([idP(tempP(length(tempP)-kList(k,1)+1:length(tempP)));idN(tempN(length(tempN)-kList(k,2)+1:length(tempN)))]))=-1;

if obj(k)<objcur
    obj(k)=objcur;
    P(:,k)=temp;
end
end
clear V Q  tempP tempN idP idN non_expert;
return;
end


clear Yall;


if nd ==2 

sV=sqrt(sum(V.^2,2));
[AmpV,IDAmpV]=sort(sV,'descend');

for k=1:1:size(kList,1)
Feta(k).id=[];
eta(k).id=[];
end
minP=AmpV(3) ;
if nd==2
count=ones(size(kList,1),1);
Chk=1;
for i=2:1:length(AmpV)
     disp(i);
     if i > sum(Mk) 
      if AmpV(i) <  minP
         return;
     end
     end
     if i>  100
      if Chk==0
         return;
     else
     Chk=0;
      end
     end
     for j=1:1:i-1
iSelect=[IDAmpV(i),IDAmpV(j)]';
temp=V(iSelect,:)-V(iSelect([2,1]),:);
c=null(temp);
cV=V*c;
clear temp;
[~,tempP]=sort(cV(idP),'descend');
[~,tempN]=sort(cV(idN),'descend');
idp=idP(tempP(1:Mk(1)));
idn=idN(tempN(1:Mk(2)));
for PosNeg=1:1:2
    if PosNeg==2
        tempP=tempP(length(tempP):-1:1);
        tempN=tempN(length(tempN):-1:1);
    end
for k=1:1:size(kList,1)
   id=[idp(1:kList(k,1));idn(1:kList(k,2)) ];
   eta(k).id=[eta(k).id,id];
   count(k)=count(k)+1;

if k==size(kList,1)
if length(find(id==iSelect(1)))>0 | length(find(id==iSelect(2)))>0
if minP>abs(cV(iSelect(1)))
    minP=abs(cV(iSelect(1)))
end
end
end

if sum(Y(iSelect))>1
temp= length(find(idp(1:kList(k,1))==iSelect(1)))  + length(find(idp(1:kList(k,1))==iSelect(2))) ;
if temp==1
if length(find(id==iSelect(1)))>0 
    id =[setdiff(id,iSelect(1));iSelect(2)];
else
    id =[setdiff(id,iSelect(2));iSelect(1)];
end

eta(k).id=[eta(k).id,id];
count(k)=count(k)+1;
end
elseif sum(Y(iSelect))<-1
temp= length(find(idn(1:kList(k,2))==iSelect(1)))  + length(find(idn(1:kList(k,2))==iSelect(2))) ;
if temp ==1
  if length(find(id==iSelect(1)))>0 
    id =[setdiff(id,iSelect(1));iSelect(2)];
else
    id =[setdiff(id,iSelect(2));iSelect(1)];
  end
eta(k).id=[eta(k).id,id];
count(k)=count(k)+1;  
end
end
end
end

if max(count)>250
	for k=1:1:size(kList,1)
		A=sort(eta(k).id',2);
		eta(k).id=[];
		count(k)=1;
		temp=find(ismem(A,Feta(k).id')==0); 
		if length(temp)>0
    			Chk=1;
			Feta(k).id=[Feta(k).id,A(temp,:)']

			tempe=ones(N,length(temp));
			tempe2=ones(length(Y),length(temp));

			for t=1:1:length(temp)
				tempid = A(temp(t),:)'; 
				tempe(non_expert(tempid),t)=-1;
				tempe2(tempid,t)=-1;
			end
			objtemp=sum(tempe2.*(Q*tempe2))';
			[objcur,indexcur]=max(objtemp)
			clear objtemp;
			if obj(k)<objcur
    				obj(k)=objcur;
    				P(:,k)=tempe(:,indexcur);
			end
		end
	end
disp(max(obj));
end

end
end

for k=1:1:size(kList,1)
                A=sort(eta(k).id',2);
                eta(k).id=[];
                count(k)=1;
                temp=find(ismem(A,Feta(k).id')==0);
                if length(temp)>0
                        Chk=1;
                        Feta(k).id=[Feta(k).id,A(temp,:)']

                        tempe=ones(N,length(temp));
                        tempe2=ones(length(Y),length(temp));

                        for t=1:1:length(temp)
                                tempid = A(temp(t),:)';
                                tempe(non_expert(tempid),t)=-1;
                                tempe2(tempid,t)=-1;
                        end
                        objtemp=sum(tempe2.*(Q*tempe2))';
                        [objcur,indexcur]=max(objtemp)
                        clear objtemp;
                        if obj(k)<objcur
                                obj(k)=objcur;
                                P(:,k)=tempe(:,indexcur);
                        end
                end
        end
disp(max(obj));


clear eta V;
return;
end
end

if nd ==3
for i=3:1:length(AmpV)
for j=2:1:i-1
for l=1:1:j-1
count=ones(size(kList,1),1);


iSelect=[IDAmpV(i),IDAmpV(j),IDAmpV(l)]';

temp=V(iSelect,:)-V(iSelect([2,3,1]),:);
c=null(temp);
[~,tempP]=sort(V(idP,:)*c,'descend');
[~,tempN]=sort(V(idN,:)*c,'descend');

for k=1:1:size(kList,1)
id=sort([idP(tempP(1:kList(k,1)));idN(tempN(1:kList(k,2)))]);
eta(k).id(:,count(k))=non_expert(id);
count(k)=count(k)+1;



if sum(Y(iSelect))>0
    
temp= intersect(idP(tempP(1:kList(k,1))),iSelect);
if length(temp)>0 & length(temp)<3
tempy=find(Y(iSelect)==1);
tempnew=nchoosek([1:1:length(tempy)],length(temp));
for rnew=1:1:size(tempnew,1)
id =unique([setdiff(idP(tempP(1:kList(k,1))),temp);iSelect(tempy(tempnew(rnew,:)));idN(tempN(1:kList(k,2)))]);
eta(k).id(:,count(k))=non_expert(id);
count(k)=count(k)+1;
end
end
else
temp= intersect(idN(tempN(1:kList(k,2))),iSelect);
if length(temp)>0 & length(temp)<3
tempy=find(Y(iSelect)==-1);
tempnew=nchoosek([1:1:length(tempy)],length(temp));
for rnew=1:1:size(tempnew,1)
id =unique([setdiff(idN(tempN(1:kList(k,2))),temp);iSelect(tempy(tempnew(rnew,:)));idP(tempP(1:kList(k,1)))]);
eta(k).id(:,count(k))=non_expert(id);
count(k)=count(k)+1;
end
end

end
end


tempP=tempP(length(tempP):-1:1);
tempN=tempN(length(tempN):-1:1);
for k=1:1:size(kList,1)
id=sort([idP(tempP(1:kList(k,1)));idN(tempN(1:kList(k,2)))]);
eta(k).id(:,count(k))=non_expert(id);
count(k)=count(k)+1;

if sum(Y(iSelect))>0
if length(intersect(idP(tempP(1:kList(k,1))),iSelect))>0 & length(intersect(idP(tempP(1:kList(k,1))),iSelect))<3
temp= intersect(idP(tempP(1:kList(k,1))),iSelect);
tempy=find(Y(iSelect)==1);
tempnew=nchoosek([1:1:length(tempy)],length(temp));
for rnew=1:1:size(tempnew,1)
id =unique([setdiff(idP(tempP(1:kList(k,1))),temp);iSelect(tempy(tempnew(rnew,:)));idN(tempN(1:kList(k,2)))]);
eta(k).id(:,count(k))=non_expert(id);
count(k)=count(k)+1;
end
end
else
if length(intersect(idN(tempN(1:kList(k,2))),iSelect))>0 & length(intersect(idN(tempN(1:kList(k,2))),iSelect))<3
temp= intersect(idN(tempN(1:kList(k,2))),iSelect);
tempy=find(Y(iSelect)==-1);
tempnew=nchoosek([1:1:length(tempy)],length(temp));
for rnew=1:1:size(tempnew,1)
id =unique([setdiff(idN(tempN(1:kList(k,2))),temp);iSelect(tempy(tempnew(rnew,:)));idP(tempP(1:kList(k,1)))]);
eta(k).id(:,count(k))=non_expert(id);
count(k)=count(k)+1;
end
end

end
end
for k=1:1:size(kList,1)
A=eta(k).id;
eta(k).id=[];
Feta(k).id=[Feat(k).id,unique(sort(A',2),'rows')'];
end

end
end
end

clear eta V;
return;
end
end

